<template>
  <div class="map-container">
    <div :id='mapId' style="height: 100%; width: 100%;"></div>
  </div>
</template>

<script>
  import { isNil, isEmpty } from '@/helpers';
  import 'leaflet/dist/leaflet.css';
  import L from 'leaflet';
  import icon from 'leaflet/dist/images/marker-icon.png';
  import iconShadow from 'leaflet/dist/images/marker-shadow.png';

  export default {
    name: 'MapLeaflet',
    props: {
      disabled: {
        type: Boolean,
        default: false
      },
      mapId: {
        type: String,
        default: 'mymap'
      },
      coords: {
        type: Object,
        default: () => {}
      },
      radius: {
        type: Number,
        default: NaN
      }
    },
    mounted() {
      this.initMap();
    },
    data() {
      return {
        zoom: 8,
        mymap: '',
        marker: null,
        circle: null,
        defaultCentre: {
          lat: 55.751574,
          lon: 37.573856
        }
      };
    },
    watch: {
      coords() {
        if(this.marker) {
          this.marker = this.marker.setLatLng(this.coords);
          this.mymap.setView(this.coords, this.zoom);
        }
        else {
          if(this.coords.lat && this.coords.lon) {
            this.setMarkers({
              coordinates: this.coords,
            })
          }
        }
      },
      radius() {
        this.setRadius();
      }
    },
    methods: {
      initMap() {
        let _center = (isNil(this.coords) || isEmpty(this.coords) || !this.coords.lat || !this.coords.lon) ? this.defaultCentre : this.coords;
        this.mymap = L.map(this.mapId, { zoomControl: false })
                .setView(
                        _center,
                        this.zoom
                );
        L.control
                .zoom({
                  position: 'topright',
                  zoomInText: '',
                  zoomOutText: ''
                })
                .addTo(this.mymap);

        L.tileLayer(
                'https://maps.googleapis.com/maps/vt?language=ru-RU&pb=!1m5!1m4!1i{z}!2i{x}!3i{y}!4i256!2m3!1e0!2sm!3i349018013!3m9!2sen-US!3sUS!5e18!12m1!1e47!12m3!1e37!2m1!1ssmartmaps!4e0'
        )
                .addTo(this.mymap);
        this.mymap.on('zoomend', () => {
          this.zoom = this.mymap.getZoom()
        });

        this.mymap.on('click', (e) => {
          this.$emit('input', {
            lat: e.latlng.lat,
            lon: e.latlng.lng,
          });

          this.$emit('select-point', {
            lat: e.latlng.lat,
            lon: e.latlng.lng,
          });
        });
        if(!isNil(this.coords) && !isEmpty(this.coords)) {
          let _markerObject = {
            coordinates: this.coords,
          };
          if (this.coords.lat && this.coords.lon) {
            this.setMarkers(_markerObject)
          }
        }
        if(this.radius) {
          this.setRadius();
        }
      },
      setRadius() {
        if (this.circle) {
          this.mymap.removeLayer(this.circle);
        }
        this.circle = L.circle(this.coords, this.radius * 1000).addTo(this.mymap);
        this.mymap.fitBounds(this.circle.getBounds(), { padding: [90, 90] });
        this.zoom = this.mymap.getZoom()
      },
      setMarkers(markerObject) {
        let DefaultIcon = L.icon({
          iconUrl: icon,
          shadowUrl: iconShadow,
          ashadowUrl: iconShadow,
          iconSize: [25, 41],
          iconAnchor: [12, 41]
        });
        if(!this.radius && !this.disabled) {
          L.Marker.prototype.options.draggable = true;
        }
        L.Marker.prototype.options.icon = DefaultIcon;
        this.marker = L.marker(markerObject.coordinates, {
          icon: DefaultIcon,
        })
                .addTo(this.mymap);
        this.marker.on('dragend', this.onMoveMarker);
        this.mymap.setView(markerObject.coordinates, this.zoom);
      },
      onMoveMarker() {
        let _marker = this.marker.getLatLng();
        this.$emit('input', {
          lat: _marker.lat,
          lon: _marker.lng,
        });
      }
    }
  };
</script>

<style lang="scss">
  .map-container {
    z-index: 10;
    position: relative;
  }
  .leaflet-container {
    width: 100%;
    flex-grow: 2;
  }
  .dx-overlay-content.dx-popup-normal.dx-popup-draggable.dx-resizable.dx-popup-flex-height{
    left: 50% !important;
    top:50% !important;
    transform: translate(-50%, -50%) !important;
  }
  .form-controls__left{
    margin: 6px 0 0;
  }
</style>

